/*
 * Copyright Bigeon Emmanuel (2014)
 *
 * emmanuel@bigeon.fr
 *
 * This software is a computer program whose purpose is to
 * provide a generic framework for console applications.
 *
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 */
/**
 * gclc:fr.bigeon.gclc.command.CommandProviderTest.java
 * Created on: Nov 19, 2016
 */
package fr.bigeon.gclc.command;

import static org.junit.Assert.fail;

import org.junit.Test;

import fr.bigeon.gclc.exception.InvalidCommandName;

/**
 * <p>
 * TODO
 *
 * @author Emmanuel Bigeon */
public class CommandProviderTest {

    /** Test method for
     * {@link fr.bigeon.gclc.command.CommandProvider#add(fr.bigeon.gclc.command.ICommand)}.
     *
     * @throws InvalidCommandName */
    @Test
    public final void testAdd() throws InvalidCommandName {
        final CommandProvider provider = new CommandProvider();
        try {
            provider.add(new MockCommand(null));
            fail("null name for command should be rejected");
        } catch (final InvalidCommandName e) {
            // ok
        }
        try {
            provider.add(new MockCommand(""));
            fail("null name for command should be rejected");
        } catch (final InvalidCommandName e) {
            // ok
        }
        try {
            provider.add(new MockCommand("-name"));
            fail("name with minus as starting character for command should be rejected");
        } catch (final InvalidCommandName e) {
            // ok
        }
        try {
            provider.add(new MockCommand("name command"));
            fail("name with space for command should be rejected");
        } catch (final InvalidCommandName e) {
            // ok
        }
        final ICommand mock = new MockCommand("name");
        provider.add(mock);

        try {
            provider.add(new MockCommand(mock.getCommandName()));
            fail("already existing command name should be rejected");
        } catch (final InvalidCommandName e) {
            // ok
        }

        provider.add(mock);
    }

}
